typedef signed char   COLOUR;   /* 8-bit signed   */
typedef unsigned char SCANCODE; /* 8-bit unsigned */

struct MMD0
{   unsigned long a; // dummy declaration
};

#define EXPORT                /* global (project-scope)                       */

#if defined(__MORPHOS__) || defined(__amigaos4__)
    #define chip
#endif
#ifndef __amigaos4__
    #define ZERO              (BPTR) NULL
#endif

#define DEFAULTSET             "PROGDIR:WormWars.lset"
#define DEPTH                      4
#define FONTY                      8
#define HISCOREDISTANCE           16
#define SQUAREX                   12
#define SQUAREY                   12
#define SCREENXPIXEL             640
#define SCREENYPIXEL             512
#define STARTXPIXEL              (83 + xoffset)
#define STARTYPIXEL              (16 + TBSIZE + yoffset)
#define FIELDCENTREXPIXEL  (STARTXPIXEL + ((ENDXPIXEL - STARTXPIXEL) / 2))
#define FIELDCENTREYPIXEL  (STARTYPIXEL + ((ENDYPIXEL - STARTYPIXEL) / 2))
#define INTROTILEX         (FIELDCENTREXPIXEL - 149)
#define INTROTEXTX         (FIELDCENTREXPIXEL - 129)
#define INTROY             (FIELDCENTREYPIXEL -  32)

#define MORERT                   (morphos ? 2 : 0)
#define MOREDN                   (morphos ? 2 : 0)
#define ABOUTDEPTH                 4
#define ABOUTDEPTHMASK          0x0F

#define BGWIDTH                   32 // in pixels
#define BGWORDWIDTH                2 // in words
#define BGHEIGHT                  32 // in pixels
#define SMLBGWIDTH                 8 // in pixels
#define SMLBGWORDWIDTH             1 // in words
#define SMLBGHEIGHT                8 // in pixels
#define BGPLANES                   1

#define MAX_PATH                 512

#define CENTREXPIXEL (WindowWidth  / 2)
#define CENTREYPIXEL (WindowHeight / 2)
#define YSTART       (CENTREYPIXEL - 200)

#ifdef __amigaos4__
    #define execver SysBase->lib_Version
    #define execrev SysBase->lib_Revision
#else
    #define execver SysBase->LibNode.lib_Version
    #define execrev SysBase->LibNode.lib_Revision
#endif

/* colours */

#define BLACK      0
#define LIGHTGREY  1 // Ideally white should be the 2nd colour. This
                     // enables the titlebar to render correctly.
#define DARKGREEN  2
#define DARKYELLOW 3
#define MEDIUMGREY 4
#define DARKBLUE   5
#define BLUE       6
#define GREEN      7
#define DARKRED    8
// brown is 9
#define RED       10
#define YELLOW    11
#define DARKGREY  12
#define ORANGE    13
#define PURPLE    14
#define WHITE     15

#define TBSIZE    11 // for Amiga only

// menus

#define INDEX_PROJECT          0
#define INDEX_NEW              1
#define INDEX_OPEN             2
#define INDEX_REVERT           3
// ---                         4
#define INDEX_SAVE             5
#define INDEX_SAVEAS           6
// ---                         7
#define INDEX_PROJECTDELETE    8
// ---                         9
#define INDEX_QUITTITLE       10
#define INDEX_QUITDOS         11
#define INDEX_EDIT            12
#define INDEX_CUT             13
#define INDEX_COPY            14
#define INDEX_PASTE           15
// ---                        16
#define INDEX_ERASE           17
#define INDEX_EDITDELETE      18
#define INDEX_INSERT          19
#define INDEX_APPEND          20
// ---                        21
#define INDEX_CLEARHS         22
#define INDEX_VIEW            23
#define INDEX_PREVIOUS        24
#define INDEX_NEXT            25
// ---                        26
#define INDEX_VIEWPOINTER     27
#define INDEX_VIEWTITLEBAR    28
#define INDEX_SETTINGS        29
#define INDEX_ANIMATIONS      30
#define INDEX_AUTOSAVE        31
#define INDEX_CREATEICONS     32
#define INDEX_ENGRAVEDSQUARES 33
#define INDEX_HELP            34
#define INDEX_CREATURES       35
#define INDEX_OBJECTS         36
#define INDEX_FRUITS          37
// ---                        38
#define INDEX_MANUAL          39
// ---                        40
#define INDEX_UPDATE          41
// ---                        42
#define INDEX_ABOUT           43

#define MN_PROJECT         0
#define MN_EDIT            1
#define MN_VIEW            2
#define MN_SETTINGS        3
#define MN_HELP            4

// project menu
#define IN_NEW             0
#define IN_OPEN            1
#define IN_REVERT          2
// ----------------------- 3
#define IN_SAVE            4
#define IN_SAVEAS          5
// ----------------------- 6
#define IN_PROJECTDELETE   7
// ----------------------- 8
#define IN_QUITTITLE       9
#define IN_QUITDOS        10

// edit menu
#define IN_CUT             0
#define IN_COPY            1
#define IN_PASTE           2
// ----------------------- 3
#define IN_ERASE           4
#define IN_EDITDELETE      5
#define IN_INSERT          6
#define IN_APPEND          7
// ----------------------- 8
#define IN_CLEARHISCORES   9

// view menu
#define IN_PREVIOUS        0
#define IN_NEXT            1
// ----------------------- 2
#define IN_VIEWPOINTER     3
#define IN_VIEWTITLEBAR    4

// settings menu
#define IN_ANIMATIONS      0
#define IN_AUTOSAVE        1
#define IN_CREATEICONS     2
#define IN_ENGRAVEDSQUARES 3

// help menu
#define IN_CREATURES       0
#define IN_OBJECTS         1
#define IN_FRUIT           2
// ----------------------- 3
#define IN_MANUAL          4
// ----------------------- 5
#define IN_UPDATE          6
// ----------------------- 7
#define IN_ABOUT           8

// gfx.c
EXPORT void drawabout(void);
EXPORT void drawbackground(void);
EXPORT void drawboing(void);
EXPORT void drawlogo(void);

EXPORT void swap_byteorder(UWORD* imagedata, ULONG size);
EXPORT void gfx_swap_byteorder(void);
EXPORT void squares_swap_byteorder(void);
EXPORT void heads_swap_byteorder(void);
EXPORT void tails_swap_byteorder(void);

// le.c
EXPORT void dot(void);

#ifdef __MORPHOS__
    #if EXIT_FAILURE == 1
        #undef  EXIT_FAILURE
        #define EXIT_FAILURE 20
    #endif
#else
    #define EXIT_SUCCESS  0
    #define EXIT_FAILURE 20
#endif
